
#define RUNMODE_ENUM(VARIANT)     \
   VARIANT(Runmode_DEBUG, 0)\
   VARIANT(Runmode_STANDARD, 1)

#define RUNMODE_ENUM_VARIANT(NAME, VALUE) NAME = (VALUE),

typedef enum
{
   RUNMODE_ENUM(RUNMODE_ENUM_VARIANT)
} Runmode;


#define RUNMODE_ENUM_STRING(NAME, ...) case NAME: return #NAME;
#define RUNMODE_ENUM_FROM_STRING(NAME, ...)           \
   if (0 == strcmp(string, #NAME)) return NAME;

const char *runmode_name(Runmode runmode)
{
   switch(runmode)
   {
      RUNMODE_ENUM(RUNMODE_ENUM_STRING)
      default: assert(!"Unknown runmode");
   }
}

Runmode runmode_from_string(const char *string)
{
   RUNMODE_ENUM(RUNMODE_ENUM_FROM_STRING)
   assert(!"Uknown runmode");
}


