
// Specifies the data types for channel fault and voltage data to be used
// in reports to the operator or external system.

#define NUM_CHANNELS   8

typedef struct
{
   uint16_t is_faulted;
   uint32_t voltage_uv;
   uint32_t voltage_ref_uv;
} report_t;

typedef report_t reportAll_t[NUM_CHANNELS];
